;
; SYSGEN utility for Montezuma Micro CP/M v 2.32
; for the Radio Shack Model 4 computer.
;
; Based on SYSGEN v 3.00, but modified so it really works.
;
; This source code is for the Z80ASM assembler
; from SLR systems.
;
biosvec	equ	0
wbootvec	equ	1
bdos		equ	5
bdosvec		equ	6
fcb		equ	5ch
fcbfname	equ	5dh
fcbcurrec	equ	7ch
buffer		equ	900h
;
cr		equ	0dh
lf		equ	0ah
;
	org	100h
;
start:	ld	hl,(wbootvec)	; set up bios hooks
	ld	bc,18h
	add	hl,bc
	ld	de,bioshooks	; transfer 6 vectors
	ld	bc,18		; seldsk, settrk, setsec, setdma, read, write
	ldir
	ld	sp,buffer
	ld	hl,signon
	call	printstr
	ld	a,(fcbfname)
	cp	' '
	jr	z,selectsrc	; go if no filename
	ld	de,fcb
	call	bdoscode
	db	0fh		; open file bdos code
	inc	a
	jr	nz,rdfile	; go if file opened
	ld	hl,nosrcmsg
	call	printstr
	jp	abort
;
; Read disk image of boot, ccp, bdos, and bios
; from file into buffer.
; 
rdfile:	xor	a
	ld	(fcbcurrec),a
	ld	hl,buffer
rdfil2:	push	hl
	ex	de,hl
	call	bdoscode
	db	1ah		; set dma bdos code
	call	readseq
	pop	hl
	or	a
	jr	nz,selectdst	; file read done
	ld	bc,128
	add	hl,bc
	jr	rdfil2
;
srcincomp:
	ld	hl,srcincmplmsg
	call	printstr
	jp	abort
;
selectsrc:
	ld	hl,selsrcmsg
	call	getdrvno
	jr	z,selectdst
	ld	hl,13
	add	hl,de
	ld	a,(hl)		; get reserved track count
	inc	hl
	sub	2
	or	(hl)
	jr	z,selsrc1
	ld	hl,baddrvmsg
	call	printstr
	jr	selectsrc
;
; DE->DPB
;
selsrc1:
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(spt),de
	ld	hl,plcsrcmsg
	call	prompt
	call	loadimage
; 
; BOOT, CCP, BDOS, and BIOS image is in buffer.
; Select the destination drive.
; 
selectdst:
	ld	hl,seldstmsg
	call	getdrvno
	jp	z,biosvec
	call	validatedisk
	jr	nc,seldst1
	ld	hl,baddrvmsg
	call	printstr
	jr	selectdst
;
seldst1:
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(spt),de
	ld	hl,plcdstmsg
	call	prompt
	call	saveimage
	ld	hl,donemsg
	call	printstr
	jr	selectdst
;
getchar:
	ld	de,conbfrmax
	call	bdoscode
	db	0ah		; read console buffer bdos code
	ld	a,(conbfrcnt)
	or	a
	ld	a,cr
	ret	z
	ld	a,(conbfrchr)
	cp	"a"
	ret	c
	cp	'z'+1
	ret	nc
	and	5fh
	ret
;
docrlf:	ld	a,cr
	call	prtchar
	ld	a,lf
prtchar:
	ld	e,a
	ld	c,2
	jp	bdos
;
printstr:
	ld	a,(hl)
	inc	hl
	or	a
	ret	z
	push	hl
	call	prtchar
	pop	hl
	jr	printstr
;
; Get drive number from user and verify disk.
; On exit, HL->DPH, DE->DPB (if valid disk).
; 
getdrvno:
	push	hl
	call	printstr
gtdrvn1:
	call	getchar
	ld	c,a
	push	bc
	call	docrlf
	call	docrlf
	pop	bc
	ld	a,c
	cp	cr
	jr	z,gtdrvn3
	cp	'A'
	jr	c,gtdrvn1
	cp	'P'+1
	jr	nc,gtdrvn1
	push	bc
	ld	a,c
	sub	'A'
	ld	c,a
	call	seldsk
; 
; On return from seldsk, HL->DPH
; 
	ld	a,h
	or	l
	pop	bc
	jr	nz,gtdrvn2
	ld	hl,invaldrvmsg
	call	printstr
	pop	hl
	jr	getdrvno
;
gtdrvn2:
	push	hl
	ld	de,10
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	pop	hl
; 
; At this point, DE->DPB, HL->DPH
; 
gtdrvn3:
	inc	sp
	inc	sp
	ret
;
; BIOS hooks
;
bioshooks	equ	$
seldsk:	jp	seldsk
settrk:	jp	settrk
setsec:	jp	setsec
setdma:	jp	setdma
read:	jp	read
write:	jp	write
;
; Call bdos, fetch code from stack
; 
bdoscode:
	ex	(sp),hl
	ld	c,(hl)
	inc	hl
	ex	(sp),hl
	jp	bdos
;
readseq:
	ld	de,fcb
	call	bdoscode
	db	14h		; read sequential bdos code
	ret
;
prompt:	ld	a,c
	ld	(drvletter),a
	push	bc
	call	printstr
	ld	hl,diskmsg
	call	printstr
prmpt1:	call	getchar
	cp	cr
	jr	nz,prmpt1
	call	docrlf
	call	docrlf
	pop	bc
	ld	a,c
	sub	'A'
	call	seldsk
	ret
;
; Save image in buffer to disk reserved tracks
;
saveimage:
	ld	hl,savingmsg
	call	printstr
	ld	a,0ffh
	call	rdwrimage
	ld	bc,0
	call	settrk
	ld	bc,0
	call	setsec
	ld	bc,buffer
	call	setdma
	call	read
	ret
;
; Load disk reserved tracks into buffer
;
loadimage:
	ld	hl,loadingmsg
	call	printstr
	xor	a
; 
; Read or write image from/to disk.
; If A = 0 on entry, then read, else write.
; 
rdwrimage:
	ld	(rwflag),a
	ld	hl,0
	ld	(track),hl	; start at trk0, sec 0
	ld	(sector),hl
	ld	hl,buffer
	ld	(bfrptr),hl
;
; Read/Write loop
;
rdwrimg1:
	ld	bc,(track)
	call	settrk
rdwrimg2:
	ld	bc,(sector)
	call	setsec
	ld	bc,(bfrptr)
	call	setdma
	ld	a,(rwflag)
	or	a
	jr	nz,rdwrimg3
	call	read
	jr	rdwrimg4
;
rdwrimg3:
	ld	c,2
	call	write
rdwrimg4:
	or	a
	jr	nz,diskerror
	ld	hl,(bfrptr)
	ld	bc,128
	add	hl,bc
	ld	(bfrptr),hl
	ld	hl,(sector)	; next sector
	inc	hl
	ld	(sector),hl
	ex	de,hl
	ld	hl,(spt)
	sbc	hl,de
	jr	nz,rdwrimg2
	ld	hl,biosvec
	ld	(sector),hl	; reset sector to 0
	ld	hl,(track)	; next track
	inc	hl
	ld	(track),hl
	ld	a,2
	cp	l
	jr	nz,rdwrimg1	; do for 2 reserved tracks
	ret
;
diskerror:
	ld	hl,diskerrmsg
	call	printstr
	jp	abort
;
; On entry, DE->DPB
; On return, C set if error
; 
validatedisk:
	push	bc
	push	de
	push	hl
	ld	hl,14
	add	hl,de
	ld	a,(hl)		; get # of reserved tracks
	or	a
	scf
	jr	nz,valdskdone	; abort if rsv trks > 255
	dec	hl
	ld	a,(hl)		; now get actual reserved tracks
	cp	2
	jr	c,valdskdone	; abort if less than 2
	cp	8
	ccf
	jr	c,valdskdone	; abort if 8 or more
	ld	hl,buffer+1
	ld	l,(hl)
	inc	hl
	inc	hl
	inc	hl
	bit	7,(hl)
	jp	z,invalsw
	inc	hl
	push	hl
	ld	hl,16
	add	hl,de
	ld	b,(hl)
	ld	hl,64
	inc	b
valdsk1:
	add	hl,hl
	djnz	valdsk1
	ld	a,h
	or	a
	scf
	pop	hl
	jr	z,valdskdone
	ld	(hl),0
	inc	hl
	ld	(hl),a
	inc	hl
	push	hl
	ld	hl,19
	add	hl,de
	ld	c,(hl)
	pop	hl
	ld	a,0b0h
	and	c
	xor	80h
	scf
	jr	nz,valdskdone
	bit	6,c
	jr	z,valdsk2
	inc	a
valdsk2:
	ld	(hl),a
	inc	hl
	push	hl
	ld	hl,15
	add	hl,de
	ld	c,(hl)
	xor	a
	ld	b,2
valdsk3:
	add	a,c
	djnz	valdsk3
	pop	hl
	ld	(hl),a
	inc	hl
	ld	d,h
	ld	e,l
	ld	b,30
valdsk4:
	ld	(hl),0ffh
	inc	hl
	djnz	valdsk4
	pop	hl
	push	hl
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
	or	h
	scf
	jr	z,valdskdone
	ldir
	xor	a
valdskdone:
	pop	hl
	pop	de
	pop	bc
	ret
;
invalsw:
	ld	hl,invalswcfgmsg
	call	printstr
abort:	ld	hl,termmsg
	call	printstr
	jp	biosvec
;
signon:		db	1ah,16h
		db	'TRS-80 Model 4 CP/M 2.2 SYSGEN version 4.00'
		db	15h,cr,lf
		db	'Copyright (c) 2004 The Magic Dragon'
		db	15h,,cr,lf,15h,cr,lf,16h,lf,lf,0
selsrcmsg:	db	'Select SOURCE drive for SYSGEN.',cr,lf
		db	'  [ A,B,...,P, or ENTER to skip ]:  ',0
plcsrcmsg:	db	'Place SOURCE ',0
seldstmsg:	db	'Select DESTINATION drive for SYSGEN.',cr,lf
		db	'  [ A,B,...,P, or ENTER to quit ]:  ',0
plcdstmsg:	db	'Place DESTINATION',0
loadingmsg:	db	'Loading CP/M 2.2 system tracks.',cr,lf,lf,0
savingmsg:	db	'Saving CP/M 2.2 system tracks.',cr,lf,lf,0
donemsg:	db	'SYSGEN successfully completed!',cr,lf,lf,lf,lf,0
diskmsg:	db	' disk in drive '
drvletter:	db	0,':, then push ENTER:  ',0
; 
invaldrvmsg:	db	7,'Invalid or non-exsistent drive!',cr,lf,0
nosrcmsg:	db	7,'SOURCE file not found!',cr,lf,0
srcincmplmsg:	db	7,'SOURCE file is incomplete!',cr,lf,0
diskerrmsg:	db	7,'Disk I/O error!',cr,lf,0
baddrvmsg:	db	7,'Drive unsuitable for SYSGEN!',cr,lf,0
invalswcfgmsg:	db	7,'Invalid software configuration!',cr,lf,0
termmsg:	db	'SYSGEN has been terminated due to errors.',cr,lf,lf,lf,0
; 
conbfrmax:	db	1
conbfrcnt:	db	0
conbfrchr:	db	0
spt:		dw	0
rwflag:		db	0
track:		dw	0
sector:		dw	0
bfrptr:		db	0
;
	end
;

